﻿import Vector;
#include "utilityfunctions.as"

var ball:Array = new Array();
var moveable:Array = new Array();

var penW:Number = 550;
var penH:Number = 400;

var dragging:Number=-1;
var prevMouseX:Number=0;
var prevMouseY:Number=0;

var mouseListener:Object = new Object();
mouseListener.onMouseUp = function() { releaseAnyMoveable();}
Mouse.addListener(mouseListener);

initBall();

function initBall()
{
	// Creating the ball
	for (var i:Number=0; i<10; i++)
	{
		var ballType:Number = rndRange(1,2);
		var mc:MovieClip = _root.attachMovie("ball0"+ballType,"Ball:"+_root.getNextHighestDepth(),_root.getNextHighestDepth());
	
		mc.col=false;
		mc.p = new Vector(rndRange(50,penW-50),rndRange(50,penH-50));
		mc.v = new Vector(rndRange(0,200),rndRange(1,200));
		mc._x=mc.p.x;
		mc._y=mc.p.y;	
		mc.rad=rndRange(20,50);
		mc.indx.text=i;
		mc._width=mc._height=mc.rad*2;
		mc.type=ballType;
		ball.push(mc);
	}
	
	// Creating the moveables
	for (var i:Number=0; i<5; i++)
	{
		var pic_mcl:MovieClipLoader = new MovieClipLoader();
		var mc:MovieClip = _root.attachMovie("Moveable01","Moveable01:"+_root.getNextHighestDepth(),_root.getNextHighestDepth());
		mc.p = new Vector(rndRange(50,penW-50),rndRange(50,penH-50));
		mc.v = new Vector(0,0);
		mc._x=mc.p.x;
		mc._y=mc.p.y;		
		mc.i=i;
		mc.rad=20;
		
		mc.onPress = function() 
		{
			_root.dragging=this.i;
		};
		
		moveable.push(mc);	
	}
}

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
function releaseAnyMoveable()
{
	if (dragging!=-1){moveable[dragging].v.x=moveable[dragging].v.y=0;}
	_root.dragging=-1;
}

function updateBall()
{
	if (dragging!=-1)
	{
		moveable[dragging].v.x = _root._xmouse-prevMouseX;
		moveable[dragging].v.y = _root._ymouse-prevMouseY;
	}
	
	prevMouseX=_root._xmouse;
	prevMouseY=_root._ymouse;
	
	for (var i:Number=0; i<moveable.length; i++)
	{		
		var mc:MovieClip = moveable[i];		
		mc.p.plus(mc.v);
		mc._x=mc.p.x;
		mc._y=mc.p.y;		
	}
	
	for (var i:Number=0; i<ball.length; i++)
	{
		var mc:MovieClip = ball[i];					
		
		if (mc.type==1){mc.v.y+=0.8;}
		else if (mc.type==2) {mc.v.y+=0.4;}
							
		mc.p.plus(mc.v);
		
		checkBallCollision(i);
		checkMoveableCollision(i);
		checkCollisionScreen(mc);	
		
		mc._x=mc.p.x;
		mc._y=mc.p.y;		
		
		mc._rotation += mc.v.x;
	}
	
	for (var i:Number=0; i<moveable.length; i++)
	{
		moveable[i].v.x=moveable[i].v.y=0;		
	}
}

//--------------------------------------------------------------------------
// Main loop
//--------------------------------------------------------------------------
onEnterFrame = function () 
{	
	updateBall();
}

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
function checkMoveableCollision(i:Number)
{
	// Ball a
	var a:MovieClip = ball[i];
	
	// For each and every moveable
	for (var j:Number=0; j<moveable.length; j++)
	{
		// Get movables mc
		var b:MovieClip = moveable[j];		
		
		// Work out the position vectors			
		var p3:Vector=b.p.getMinus(a.p);
		var p3n:Vector = p3.getNormalize();
	
		var totalRadius:Number = Number(a.rad)+Number(b.rad);		
		var overlapDiff:Number=totalRadius-p3.length();
		
		//check if balls collide at start
		if(overlapDiff>0)
		{				
			//move object away from the ball
			a.p.x-=p3n.x*overlapDiff;
			a.p.y-=p3n.y*overlapDiff;					
			
			//change movement, bounce off from the normal of v
			bounceBalls(a,b);					
		}				
	}
}

//--------------------------------------------------------------------------
// http://www.tonypa.pri.ee/vectors/tut10.html
//--------------------------------------------------------------------------
function checkBallCollision(i:Number)
{
	// Ball a to check against ball b
	var a:MovieClip = ball[i];
	
	// For each and every other ball
	for (var j:Number=0; j<ball.length; j++)
	{
		// As long as we arent checking against ourself
		if (i!=j)
		{			
			// Get ball b's movie clip
			var b:MovieClip = ball[j];
			
			// Work out the position vectors			
			var p3:Vector=b.p.getMinus(a.p);
			var p3n:Vector = p3.getNormalize();
		
			var totalRadius:Number = Number(a.rad)+Number(b.rad);		
			var overlapDiff:Number=totalRadius-p3.length();
			
			//check if balls collide at start
			if(overlapDiff>0)
			{				
				//move object away from the ball
				a.p.x-=p3n.x*overlapDiff;
				a.p.y-=p3n.y*overlapDiff;					
				
				//change movement, bounce off from the normal of v
				bounceBalls(a,b);					
			}				
		}		
	}
}

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
function bounceBalls(a:MovieClip,b:MovieClip)
{
	// Get vector between p6 and p7 
	var vc:Vector =  new Vector(b.p.x-a.p.x, b.p.y-a.p.y);
	var vcn:Vector = vc.getNormal();
	
	var v0a:Vector = a.v.getProject(vc);
	var v0b:Vector = a.v.getProject(vcn);
	
	var v2a:Vector = b.v.getProject(vc);
	var v2b:Vector = b.v.getProject(vcn);
	
	a.v = new Vector(v0b.x+v2a.x, v0b.y+v2a.y);
	b.v = new Vector(v0a.x+v2b.x, v0a.y+v2b.y);
	
	a.v.multiply(0.99);
	b.v.multiply(0.99);
}

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
function checkCollisionScreen(mc:MovieClip)
{
	var rad:Number=mc._width/2; var b:Boolean=false;
	if (mc.p.x<rad){mc.p.x=rad; mc.v.x=-mc.v.x; b=true;}
	if (mc.p.x>penW-rad){mc.p.x=penW-rad; mc.v.x=-mc.v.x; b=true;}
	if (mc.p.y<rad){mc.p.y=rad; mc.v.y=-mc.v.y; b=true;}
	if (mc.p.y>penH-rad){mc.p.y=penH-rad; mc.v.y=-mc.v.y; b=true;}
	if (b) {mc.v.multiply(0.8);}
}